<template src="./template.html"></template>

<script lang="ts">
import { Component, getModule, Vue, Watch } from "nuxt-property-decorator";
import { loadScript } from "@paypal/paypal-js";

import Swal from "sweetalert2";
import { apiErrorHandler, redirectPage } from "~/utils/apiHanlers";
import { api, apiLocal } from "~/common/constaint";
import CartModule from "~/store/cart";
import ProductModule from "~/store/product";
import {
  trackEventAddPaymentInfo,
  trackEventCheckoutInitiated,
  trackEventPurchased,
} from "~/utils/trackEvent";
import { objectToParam } from "~/common/utils";
import { getSessionId, randomCharacter, setSessionId } from "~/utils/sessionId";
import getIp from "~/utils/getIp";
import sitePage from "~/store/sitePage";
import { resources } from "~/interfaces/api";
import {
  onGetDate,
  onGetListCart,
  onSetItemLocalStorage,
} from "~/utils/localStorage";
import checkCart from "~/utils/checkCart";
var moment = require("moment");
@Component({
  components: {},
})
export default class ProductComponent extends Vue {
  cart = getModule(CartModule, this.$store);
  siteInfoModule = getModule(sitePage, this.$store);
  productModule = getModule(ProductModule, this.$store);
  api = api;
  config: any = {
    page: 1,
    limit: 25,
    search: "",
  };

  settings = {
    focusOnSelect: true,
    infinite: true,
    slidesToShow: 5,
    centerMode: true,
    slidesToScroll: 5,
  };
  dialogReview = false;
  dialogCommentReview = false;
  idxCarousel = 0;
  panel = 0;
  // productId: any = "";
  // product: any = {};
  productSlug = "";
  listVariant: any = [];
  imageId = "";
  payload: any = {
    productId: "",
    variantId: "",
    quantity: 1,
  };
  combo: any = {};
  listProductIds = [];
  listRelatedProductIds = [];
  listRecentlyViewed = [];
  listBestSeller = [];
  selected: any = null;
  loading = false;
  loadingBuy = false;
  loadingAddAllTocart = false;
  loadingTable = false;
  review = {
    productId: "",
    email: "",
    name: "",
    phoneNumber: "",
    rating: 0,
    content: "",
    replyTo: "",
  };
  listImgReview = [];
  listImageRender = [];
  isHeightReview = false;
  listCart: any = [];

  carouselSubItem = {
    dots: false,
    infinite: true,
    initialSlide: 1,
    speed: 500,
    slidesToShow: 6,
    slidesToScroll: 1,
    centerMode: true,
    centerPadding: "20px",
    focusOnSelect: true,
    swipeToSlide: true,
    arrows: true,
    responsive: [
      {
        breakpoint: 575,
        settings: {
          slidesToShow: 6,
        },
      },
    ],
  };

  get listImage() {
    return this.$store.state?.product?.listImage || [];
  }

  set listImage(value) {
    this.$store.commit("product/setListImage", value);
  }

  get reviews() {
    return this.$store.state?.product?.product?.reviews || [];
  }
  get loadingPaypal() {
    return this.$store.state.product.loadingPaypal;
  }
  get publicKeyPaypal() {
    return this.$store.state.cart.publicKeyPaypal;
  }
  get enablePaypal() {
    const listPayment = this.$store.state.cart?.listPayment || [];
    const findIndex = listPayment.findIndex(
      (payment: any) => payment.type === "paypal"
    );
    if (findIndex !== -1) {
      return this.$store.state.cart?.listPayment[findIndex]?.status;
    }
    return false;
  }

  get enableCardPaypal() {
    const listPayment = this.$store.state.cart?.listPayment || [];
    const findIndex = listPayment.findIndex(
      (payment: any) => payment.type === "paypal"
    );
    if (findIndex !== -1) {
      return listPayment[findIndex]?.isOpenPaypalCard;
    }
    return false;
  }

  get peopleViewing() {
    return this.$store.state?.setting?.siteInfo?.productDisplay?.peopleViewing;
  }

  get purchased() {
    return this.$store.state?.setting?.siteInfo?.productDisplay?.purchased;
  }

  get lastMinute() {
    // const secondCurrent = localStorage.getItem("secondCurrent");
    return this.$store.state?.setting?.siteInfo?.productDisplay?.lastMinute;
  }

  get myIp() {
    return this.$store.state?.sitePage?.myIp || {};
  }

  get templateType() {
    return this.$store.state?.setting?.siteInfo.templateType || "1";
  }

  isClickImage = "carousel-right";
  parseImageThumb = "";
  minutes = 13;
  second = 59;
  secondCurrent = 0;
  percentEndIn = 100;
  timerInterVal: any = null;
  timerInterValCarousel: any = null;

  countImgThumb = 0;

  drawerReview = false;
  isCheckScreenMobile = false;
  customerReview = {
    name: "",
    title: "",
    content: "",
    rate: 5,
  };
  openDialogWriteReview() {
    this.customerReview = {
      name: "",
      title: "",
      content: "",
      rate: 5,
    };
    this.drawerReview = true;
  }

  onSubmitReview() {
    if (
      !(
        this.customerReview.name &&
        this.customerReview.title &&
        this.customerReview.content
      )
    ) {
      return this.$pushNotification.error(
        `${this.$language.pleaseEnterAllField}`
      );
    }

    this.drawerReview = false;
    Swal.fire({
      title: `${this.$language.success}`,
      text: `${this.$language.reviewSuccess}`,
      icon: "success",
      confirmButtonColor: "#41b882",
      confirmButtonText: `${this.$language.agree}`,
    });
  }

  countdownTimer() {
    if (this.second === 0 && this.minutes > 0) {
      this.second = 60;
      this.minutes -= 1;
    }
    if (this.minutes === 0 && this.second === 1) {
      clearInterval(this.timerInterVal);
      // this.setLastMinutes();
    }
    this.second -= 1;
    this.secondCurrent = this.minutes * 60 + this.second;
    this.percentEndIn = Math.round(
      (this.secondCurrent / this.lastMinute) * 100
    );
    localStorage.setItem("secondCurrent", JSON.stringify(this.secondCurrent));
    if (this.percentEndIn <= 20) {
      localStorage.setItem("percentEndIn", JSON.stringify(this.percentEndIn));
      clearInterval(this.timerInterVal);
    }
  }
  countdownTimerCarousel() {
    this.secondCarousel -= 1;
    if (this.secondCarousel === 0 && this.minutesCarousel > 0) {
      this.secondCarousel = 59;
      this.minutesCarousel -= 1;
    }
    if (this.minutesCarousel === 0 && this.secondCarousel === 0) {
      clearInterval(this.timerInterValCarousel);
    }
  }
  beforeDestroy() {
    //@ts-ignore
    document.getElementById("cart-fixed-bottom").classList.add("d-none");
    //@ts-ignore
    document.getElementById("cart-fixed-bottom").classList.remove("d-block");
    this.$store.commit("cart/setDrawerProduct", false);
    this.$store.commit("product/setIsDonePaypalHome", false);
    clearInterval(this.timePeopleView);
    clearInterval(this.timeLeftInStock);
  }

  head() {
    return {
      title:
        this.$store.state.setting.siteInfo &&
        this.$store.state.setting.siteInfo.webTitle,
      link: [
        {
          rel: "icon",
          type: "image/x-icon",
          href: `${
            this.$store?.state?.setting?.siteInfo?.logo
              ? `${api}/${this.$store?.state?.setting?.siteInfo?.logo}`
              : "/logous.png"
          }`,
        },
      ],
      script: [
        {
          type: "text/javascript",
          innerHTML: `(function (e, t, n) {
    if (e.snaptr) return; var a = e.snaptr = function () { a.handleRequest ? a.handleRequest.apply(a, arguments) : a.queue.push(arguments) };
    a.queue = []; var s = 'script'; r = t.createElement(s); r.async = !0;
    r.src = n; var u = t.getElementsByTagName(s)[0];
    u.parentNode.insertBefore(r, u);
})(window, document,
    'https://sc-static.net/scevent.min.js');`,
        },
      ],
    };
  }
  created() {
    this.setLastMinutes();
    this.randomPeopleView();
    this.countDownLeftInStock();
    //@ts-ignore
    if (this.$vuetify.breakpoint.name === "xs") {
      this.settings = {
        focusOnSelect: true,
        infinite: true,
        slidesToShow: 5,
        slidesToScroll: 5,
        centerMode: true,
      };
      this.isCheckScreenMobile = true;
    }
    //@ts-ignore
    if (this.$vuetify.breakpoint.name === "sm") {
      this.settings = {
        focusOnSelect: true,
        infinite: true,
        slidesToShow: 5,
        slidesToScroll: 5,
        centerMode: true,
      };
      this.isCheckScreenMobile = true;
    }
    if (
      //@ts-ignore
      this.$vuetify.breakpoint.name !== "xs" &&
      //@ts-ignore
      this.$vuetify.breakpoint.name !== "sm"
    ) {
      this.settings = {
        focusOnSelect: true,
        infinite: true,
        slidesToShow: 5,
        slidesToScroll: 5,
        centerMode: true,
      };
    }
  }

  isLazyLoad = true;

  get lazyloading() {
    return this.$store.state.sitePage.lazyloading || false;
  }

  set lazyloading(value: boolean) {
    this.$store.commit("sitePage/setLazyLoading", value);
  }

  async mounted() {
    this.listCart = onGetListCart();
    if (!this.productId) {
      this.siteInfoModule.setLoadingFullPage(true);
      const proms = [
        this.getListUpsale(),
        this.getDetailProduct(),
        this.onGetListPayment(),
        // this.onGetDiscount(),
        this.onGetListShipping(),
      ];
      await Promise.all(proms);
    } else {
      checkCart(this, this.product);
    }
    this.setScriptPaypal();
    this.siteInfoModule.setLoadingFullPage(false);
    getIp(this.$store, this.$api);
    // this.onGetListCart();
    this.onCountView();
    // handleTwitter(this);
    // clearInterval(this.x);
    // this.timerInterVal = setInterval(() => {
    //   this.countdownTimer();
    // }, 1000);
    if (
      this.product &&
      this.product.listVariantSellerId &&
      this.product.listVariantSellerId.length
    ) {
      this.product.listVariantSellerId.forEach((variant: any) => {
        variant.selected = 0;
      });
    }
    if (this.product?.listVariantSellerId?.length) {
      this.changedCarouselRight(this.product.listVariantSellerId[0]._id, 0);
    } else {
      this.idxCarousel = 0;
      this.isClickImage = "carousel-left";
      this.changedCarousel(0);
    }
    this.onCalcTimer();
    this.lazyloading = false;
  }

  clickPrevCarousel() {
    if (this.idxCarousel > 0) this.idxCarousel -= 1;
    else this.idxCarousel = this.listImage.length - 1;
    this.changedCarousel(this.idxCarousel);
  }

  clickNextCarousel() {
    if (this.idxCarousel === this.listImage.length - 1) this.idxCarousel = 0;
    else this.idxCarousel += 1;
    this.changedCarousel(this.idxCarousel);
  }

  async getListUpsale() {
    await this.productModule.getListUpsale({ ctx: this });
  }

  async getDetailProduct() {
    await this.productModule.getDetailProduct({ ctx: this });
  }

  async onGetDiscount() {
    const storeId = this.$store.state.setting?.siteInfo?.storeId || "";
    this.$store.dispatch("product/getListDiscount", { ctx: this, storeId });
  }

  countryCodePayment = "";
  nameShipping = "";
  async onGetListShipping() {
    try {
      this.loadingTable = true;
      this.countryCodePayment = this.myIp.countryCode || "";
      const domain = this.$store.state?.product?.domain || "";
      const response = await this.$api.shipping.listShipping(
        domain,
        this.countryCodePayment,
        this.siteInfo.adminId
      );
      if (response?.data?.length) {
        this.$store.commit("product/setListShipping", response.data);
        this.$store.commit("product/getPriceShipping", {
          listCart: this.listCart,
          totalP: this.totalPrice,
        });
      }
    } catch (error) {
      apiErrorHandler(error, this);
    } finally {
      this.loadingTable = false;
    }
  }

  async onGetListPayment() {
    try {
      const domain = this.$store.state?.product?.domain || "";
      const responseListPayment = await this.$axios.$get(
        `${apiLocal()}/${resources.PaymentBuyer}/list/${domain}`
      );
      this.$store.commit("cart/setListPayment", responseListPayment?.data);
      this.$store.commit("cart/setPublicKey", responseListPayment?.data);
    } catch (error) {
      apiErrorHandler(error, this);
    }
  }

  async onGetListCart() {
    try {
      const product = this.$store.state?.product?.product || {};
      const cart = onGetListCart();
      const cardFinal = cart.filter(
        (item: any) => item.productName === product.productName
      );
      localStorage.setItem("cart", JSON.stringify(cardFinal));
      this.$store.commit("cart/setListCart", cardFinal);
    } catch (error) {
      apiErrorHandler(error, this);
    }
  }

  async onCountView() {
    try {
      let sessionId = getSessionId();
      if (!sessionId) {
        const charRandom = randomCharacter().toLocaleLowerCase();
        const unixTimeStamp = Math.floor(new Date().getTime() / 1000);
        sessionId = `${charRandom}_${unixTimeStamp}`;
        setSessionId(sessionId);
      }
      const query = this.$store.state.sitePage.utm || {};
      const storeId = this.siteInfo?.storeId || "";
      await this.$api.product.getDetailProduct(
        sessionId,
        storeId,
        this.siteInfo.adminId,
        query
      );

      let date = onGetDate();
      if (!date) {
        date = moment().format("YYYY-MM-DD");
      }
      const dateCurrency = moment().format("YYYY-MM-DD");
      const dayDiff = moment(date).diff(dateCurrency, "days");
      if (dayDiff < 0) {
        date = dateCurrency;
      }
      onSetItemLocalStorage("date", date);
    } catch (error) {
      apiErrorHandler(error, this);
    }
  }
  peopleViewingView = 0;
  timePeopleView: ReturnType<typeof setInterval> | undefined = undefined;
  randomPeopleView() {
    this.peopleViewingView = this.peopleViewing;
    this.timePeopleView = setInterval(() => {
      this.peopleViewingView = this.randomIntFromInterval(
        this.peopleViewing,
        this.peopleViewing + 1000
      );
    }, 6000);
  }

  leftInStock = 259;
  timeLeftInStock: ReturnType<typeof setInterval> | undefined = undefined;
  countDownLeftInStock() {
    //@ts-ignore
    this.leftInStock = JSON.parse(localStorage.getItem("leftInStock")) || 259;
    this.timeLeftInStock = setInterval(() => {
      if (this.leftInStock === 49) {
        this.leftInStock = 260;
      }
      this.leftInStock -= 1;
      localStorage.setItem("leftInStock", JSON.stringify(this.leftInStock));
    }, 5000);
  }

  get purchasedView() {
    return Math.round(this.peopleViewingView / 3);
  }

  get calcReview() {
    let total = 0;
    for (let item of this.reviews) {
      total += item.rating;
    }
    return Math.round(total / this.reviews.length) || 0;
  }

  randomIntFromInterval(min: number, max: number) {
    return Math.floor(Math.random() * (max - min + 1) + min);
  }

  setLastMinutes() {
    clearInterval(this.timerInterVal);
    //@ts-ignore
    // const percentEndIn = JSON.parse(localStorage.getItem("percentEndIn")) || 0;
    // if (percentEndIn) {
    //   if (percentEndIn <= 20) {
    //     this.percentEndIn = percentEndIn;
    //     return;
    //   }
    // }
    const lastMinute = this.lastMinute;
    if (lastMinute) {
      this.minutes = Math.floor(lastMinute / 60);
      this.second = lastMinute % 60;
    }
    this.timerInterVal = setInterval(() => {
      this.countdownTimer();
    }, 1000);

    clearInterval(this.timerInterValCarousel);
    this.timerInterValCarousel = setInterval(() => {
      this.countdownTimerCarousel();
    }, 1000);
  }
  // ----------------------------------------------------------- PAYPAL --------------------------------------------------------------
  // async onGetListShipping() {
  //   try {
  //     this.loadingTable = true;
  //     const response = await this.$api.shipping.listShipping(this.config);
  //     if (response?.data?.data) {
  //       this.listShipping = response.data.data;
  //     }
  //   } catch (error) {
  //     apiErrorHandler(error, this);
  //   } finally {
  //     this.loadingTable = false;
  //   }
  // }

  async setScriptPaypal() {
    let paypal;
    if (this.publicKeyPaypal) {
      try {
        paypal = loadScript({
          "client-id": this.publicKeyPaypal,
        }).then(() => {
          this.setLoaded().then(() => {
            this.$store.commit("product/setIsDonePaypalHome", true);
          });
        });
      } catch (error) {}
    }
    this.$store.commit("product/setLoadingPaypal", false);
  }
  async setLoaded() {
    const that = this;
    //@ts-ignore
    const paypal: any = window.paypal;
    let orderCodePaypal = "";
    let paymentMethodId = "";
    const domain = this.$store.state.product?.domain || "";

    let amount = 0;
    for (let cart of this.listCart) {
      amount += cart.quantity;
    }
    //@ts-ignore
    await window.paypal
      .Buttons({
        createOrder: async function (data: any, actions: any) {
          try {
            that.$gtag.event("payment_click_paypal", {
              event_category: "click paypal",
              event_label: "click paypal",
            });
            const listSelectedProduct = [
              {
                // productId: that.productId,
                variantSellerId: that.payload.variantId,
                quantity: parseInt(that.payload.quantity),
              },
            ];
            trackEventCheckoutInitiated(that);
            const bodyTrack = {
              productName: that.product?.productName || "",
              value: that.findVariant?.price || 0,
            };
            trackEventAddPaymentInfo(that, bodyTrack);
            that.$gtag.event("form_submissions", {
              value: `${that.product?.productName || ""} ${
                that.findVariant?.price || 0
              }`,
              currency: "USD",
            });
            let sessionId = getSessionId();
            if (!sessionId) {
              const charRandom = randomCharacter().toLocaleLowerCase();
              const unixTimeStamp = Math.floor(new Date().getTime() / 1000);
              sessionId = `${charRandom}_${unixTimeStamp}`;
              setSessionId(sessionId);
            }
            const body = {
              listSelectedProduct,
              countryIp: that.myIp.countryCode || "global",
              sessionId,
            };
            const query = that.$store.state.sitePage.utm || {};
            const response = await that.$api.cart.paypalCreateOrderDirect(
              body,
              domain,
              query
            );
            if (response && response.data) {
              paymentMethodId = response.data.paymentMethodId;
              orderCodePaypal = response.data.orderCode;
              return response.data.id;
            }
          } catch (error: any) {
            const message =
              error?.response?.data?.message || error?.message || error || "";
            that.$gtag.event("purchase fail", {
              error: message,
              product_id: that.listCart[0]?._id,
              event_label: "fail paypal",
            });
            that.$sentry.captureException(message || "An error occurred");
            apiErrorHandler(error, that);
          }
        },
        onApprove: async function (data: any, actions: any) {
          const { paymentID, payerID } = data;
          if (!paymentID || !payerID || !paymentMethodId) return;
          const response = await that.$api.cart.completePaypalPayment({
            paymentMethodId,
            paymentID,
            payerID,
          });
          if (response.data) {
            const bodyTrack = {
              quantity: amount || 1,
              total: that.findVariant.price || 1,
              productName: that.listCart[0]?.productName || "",
              listSelectedProduct: that.listCart.map((cart: any) => ({
                orderCode: response?.data?.orderCode || "",
                quantity: cart.quantity || 1,
                price: cart.price || 1,
              })),
              email: response?.data?.email || "",
              phoneNumber: response?.data?.phoneNumber || "",
              orderCode: response?.data?.orderCode || "",
            };
            trackEventPurchased(that, bodyTrack);
            that.$gtag.event("purchase", {
              event_label: `purchase paypal`,
              currency: "USD",
            });
            that.$router.push(
              `/order-success?email=${
                response.data.email
              }&order_code=${response.data.orderCode.replace("#", "")}`
            );
          }
        },
        //@ts-ignore
        onCancel: async function (isFail?: boolean) {
          Swal.fire({
            title: `${that.$language.failed}`,
            text: `${that.$language.cancelSuccessfully}`,
            icon: "error",
            confirmButtonColor: "#FF5252",
            confirmButtonText: "Agree",
          });
          that.$gtag.event("cancel_click_paypal", {
            event_category: "click cancel paypal",
            event_label: "click cancel paypal",
          });
          that.onDeleteOrder(orderCodePaypal);
        },
        //@ts-ignore
        fundingSource: that.enableCardPaypal
          ? undefined
          : paypal.FUNDING.PAYPAL,
      })
      //@ts-ignore
      .render(this.$refs.paypal);
  }
  async onDeleteOrder(orderCodePaypal: string) {
    try {
      this.$axios.setHeader(
        "secret",
        "RtV30HXkxzgdV3SX83XK4UuR7k2z9mtZ0Kxo1DYkHpt4CLF9gPM4u7ysa0cWIWwXqJUCSVut7gIouorFSrbVuejy5HghYdr9TQLm"
      );
      await this.$api.order.deleteOrder(orderCodePaypal);
    } catch (error) {}
  }
  async onGetListBestSeller() {
    try {
      const response = await this.$api.product.getBestSeller(this.slug);
      if (response?.data) {
        if (response.data.length) {
          response.data.forEach((item: any) => {
            item.productId.variant.forEach((variant: any) => {
              variant.name = variant.listValue.join(" / ");
            });
          });
        }
        this.listBestSeller = response.data;
      }
    } catch (error) {
      apiErrorHandler(error, this);
    }
  }

  async onGetListCombo() {
    try {
      const response = await this.$api.combo.getComboByProduct(this.slug);
      if (response.data) {
        response.data.listProductId.forEach((product: any) => {
          if (product.variant.length) {
            product.variantId = product.variant[0]._id;
          }
        });
        response.data.listProductId.forEach((product: any) => {
          if (product.variant && product.variant.length) {
            product.variant.forEach((variant: any) => {
              variant.name = variant.listValue.join(" / ");
            });
          }
        });
        this.combo = response.data;
      }
    } catch (error) {
      apiErrorHandler(error, this);
    }
  }
  openDialogReview() {
    this.review = {
      productId: this.product._id,
      email: "",
      name: "",
      phoneNumber: "",
      rating: 5,
      content: "",
      replyTo: "",
    };
    this.dialogReview = true;
  }
  // async onGetListReviewProduct() {
  // 	try {
  // 		this.loadingTable = true;
  // 		const response = await this.$api.product.listProductReview(
  // 			this.product.slug
  // 		);
  // 		if (response?.data) {
  // 			this.$store.commit(
  // 				"product/setListReviewProduct",
  // 				response.data
  // 			);
  // 		}
  // 	} catch (error) {
  // 		apiErrorHandler(error, this);
  // 	} finally {
  // 		this.loadingTable = false;
  // 	}
  // }
  async onReviewProduct() {
    try {
      if (
        !(
          this.review.email &&
          this.review.name &&
          this.review.phoneNumber &&
          this.review.content
        )
      ) {
        return this.$pushNotification.error(
          this.$language.pleaseCompleteAllInformation
        );
      }
      this.loading = true;
      const formData = new FormData();
      formData.append("productId", this.product._id);
      formData.append("email", this.review.email);
      formData.append("name", this.review.name);
      formData.append("phoneNumber", this.review.phoneNumber);
      //@ts-ignore
      formData.append("rating", this.review.rating);
      formData.append("content", this.review.content);
      for (let img of this.listImgReview) {
        formData.append("images", img);
      }
      await this.$api.product.productReview(formData);
      this.dialogReview = false;
      this.listImgReview = [];
      this.listImageRender = [];
      Swal.fire({
        title: `${this.$language.completed}`,
        text: `${this.$language.feedbackDone}`,
        icon: "success",
        confirmButtonColor: "#41b882",
        confirmButtonText: `${this.$language.done}`,
      });
    } catch (error) {
      apiErrorHandler(error, this);
    } finally {
      this.loading = false;
    }
  }
  reviewInfo = {};
  openDialogReplyComment(review: any) {
    if (review) {
      this.review = {
        productId: this.product._id,
        email: "",
        name: "",
        phoneNumber: "",
        rating: 5,
        content: "",
        replyTo: review._id,
      };
      this.reviewInfo = review;
      this.dialogCommentReview = true;
    }
  }
  async onCommentReviewProduct() {
    try {
      if (
        !(
          this.review.email &&
          this.review.name &&
          this.review.phoneNumber &&
          this.review.content
        )
      ) {
        return this.$pushNotification.error(
          this.$language.pleaseCompleteAllInformation
        );
      }
      this.loading = true;
      const formData = new FormData();
      formData.append("productId", this.product._id);
      formData.append("email", this.review.email);
      formData.append("name", this.review.name);
      formData.append("phoneNumber", this.review.phoneNumber);
      //@ts-ignore
      formData.append("rating", this.review.rating);
      formData.append("content", this.review.content);
      formData.append("replyTo", this.review.replyTo);
      await this.$api.product.replyReview(formData);
      this.dialogCommentReview = false;
      Swal.fire({
        title: `${this.$language.completed}`,
        text: `${this.$language.reviewDone}`,
        icon: "success",
        confirmButtonColor: "#41b882",
        confirmButtonText: `${this.$language.done}`,
      });
    } catch (error) {
      apiErrorHandler(error, this);
    } finally {
      this.loading = false;
    }
  }
  onSelectImage() {
    //@ts-ignore
    this.$refs.fileImage.$refs.input.click();
  }
  onChangeImage(e: any) {
    if (e.length > 0 && e.length < 4) {
      this.listImgReview = [];
      this.listImageRender = [];
      for (let item of e) {
        if (!item.type.includes("image/")) {
          continue;
        }
      }
      this.listImgReview = e;
      for (let item of e) {
        this.createImage(item);
      }
    } else {
      return this.$pushNotification.error(
        `${this.$language.onlyUpThreePictures}`
      );
    }
  }
  createImage(e: any) {
    const reader = new FileReader();
    reader.onload = (e) => {
      //@ts-ignore
      this.listImageRender.push(e.target.result);
    };
    reader.readAsDataURL(e);
  }
  get productId() {
    return this.$store.state.product.productId;
  }
  get product() {
    const productStore = this.$utils.cloneDeep(
      this.$store.state.product.product
    );
    if (
      productStore.listVariantSellerId &&
      productStore.listVariantSellerId.length
    ) {
      // this.listImage = unionBy(this.listImage, "imageUrl");
      this.listVariant = productStore.listVariantSellerId;
      this.listVariant.forEach((variant: any) => {
        if (variant && variant.imageId && variant.imageId.imageUrl) {
          variant.imageId.imageUrl = `${variant?.imageId?.imageUrl || ""}`;
        }
      });
    }
    return productStore;
  }

  get slug() {
    return this.$store.state?.product?.slug || "";
  }

  get upsale() {
    return this.$store.state?.product?.upsale || {};
  }

  get minutesCarousel() {
    return this.$store.state?.product?.upsale.minutes || 0;
  }

  set minutesCarousel(val: number) {
    this.$store.commit("product/setMinutes", val);
  }

  get secondCarousel() {
    return this.$store.state?.product?.upsale.second || 0;
  }

  set secondCarousel(val: number) {
    this.$store.commit("product/setSecond", val);
  }

  get $language() {
    return this.$store.state.product.language;
  }

  get domain() {
    return this.$store.state?.product?.domain || "";
  }

  get buyMore() {
    return this.$store.state.setting?.siteInfo?.buyMore || {};
  }

  get saveButton() {
    return this.$store.state.setting?.siteInfo?.saveButton;
  }

  get colorVariant() {
    return this.$store.state.setting?.siteInfo?.colorVariant || "#fb5607";
  }

  dialogShowImg = false;
  image = {};
  openDialogShowImg(item: any) {
    this.dialogShowImg = true;
    this.image = item;
  }

  onAddUpsale(quantity: number) {
    this.onAddToCart(quantity);
  }

  async onAddToCart(quantity?: number, value?: boolean) {
    try {
      if (!value) {
        this.loading = true;
      }
      await this.$store
        .dispatch("cart/onAddToCart", {
          ctx: this,
          variantId: this.findVariant._id,
          product: this.product,
          quantityProduct: quantity || this.payload.quantity,
          domain: this.domain,
          isBuyItNow: value || false,
        })
        .then(() => {
          if (!value) {
            this.$store.commit("cart/setDrawerProduct", true);
          }
        });
    } catch (error) {
      apiErrorHandler(error, this);
    } finally {
      this.loading = false;
      this.payload.quantity = 1;
    }
  }
  async onBuyItNow() {
    try {
      this.loadingBuy = true;
      await this.onAddToCart(this.payload.quantity, true);
      const query = this.$store.state.sitePage.utm || {};
      this.$router.push(`/checkout?${objectToParam(query)}`);
    } catch (error: any) {
      const message = error?.response?.data?.message || "";
      this.$sentry.captureException(
        error.response?.data || "An error occurred"
      );
      this.loadingBuy = false;
      apiErrorHandler(error, this);
    }
  }

  // async f() {
  //   try {
  //     //@ts-ignore
  //     const cartInfo = JSON.parse(localStorage.getItem("cartInfo"));
  //     this.payload.productId = this.productId;
  //     if (!cartInfo) {
  //       return this.$pushNotification.error("CartId not found");
  //     }
  //     if (!this.payload.productId) {
  //       return this.$pushNotification.error("No products found");
  //     } else if (this.payload.quantity < 1) {
  //       return this.$pushNotification.error(
  //         `${this.$language.numberNotBeLess1}`
  //       );
  //     }
  //     //@ts-ignore
  //     const listAddToCart = [];
  //     listAddToCart.push(this.payload);
  //     for (let id of this.listProductIds) {
  //       const findProduct = this.combo.listProductId.find(
  //         (product: any) => product._id === id
  //       );
  //       if (findProduct) {
  //         listAddToCart.push({
  //           productId: findProduct._id,
  //           variantId: findProduct.variantId,
  //           quantity: 1,
  //         });
  //       }
  //     }
  //     for (let id of this.listRelatedProductIds) {
  //       const findProduct = this.product.relatedProduct.find(
  //         (product: any) => product._id === id
  //       );
  //       if (findProduct) {
  //         listAddToCart.push({
  //           productId: findProduct._id,
  //           variantId: findProduct.variantId,
  //           quantity: 1,
  //         });
  //       }
  //     }
  //     const payload = {
  //       listAddToCart,
  //     };
  //     const response = await this.$api.cart.addAllToCart(cartInfo._id, payload);
  //     trackEventAddToCart(this);
  //     await this.$store.commit("cart/setCartInfoAdded", response.data);
  //     await this.$store
  //       .dispatch("cart/getListCart", {
  //         ctx: this,
  //         cartId: cartInfo._id,
  //       })
  //       .then(() => {
  //         this.$pushNotification.success(
  //           `${this.$language.addToCartSuccessfully}`
  //         );
  //         redirectPage("/cart");
  //       });
  //   } catch (error) {
  //     apiErrorHandler(error, this);
  //   } finally {
  //     this.loadingAddAllTocart = false;
  //   }
  // }
  onDecrease() {
    this.payload.quantity -= 1;
  }
  onIncrease() {
    this.payload.quantity += 1;
  }
  openDialogAddTocart() {
    this.$store.commit("product/setDialogAddToCart", true);
  }
  changedCarousel(i: number) {
    this.isClickImage = "carousel-left";
    this.parseImageThumb = "";
    this.idxCarousel = i;
    if (this.listImage && this.listImage[i] && this.listImage[i].imageId) {
      this.imageId = this.listImage[i].imageId;
    }
  }
  isShowCarousel = true;
  variantActive: any = {};

  findVariant: any = {};
  async changedCarouselRight(id: string, idx: number, variant?: any) {
    this.isClickImage = "carousel-right";
    // const findVariant = this.listVariant[idx];
    // if (findVariant && findVariant._id) {
    // 	this.payload.variantId = findVariant._id;
    // }
    if (
      this.product.listVariantOptionId &&
      this.product.listVariantOptionId.length
    ) {
      let product = this.$utils.cloneDeep(this.product);
      product.listVariantOptionId.forEach((variant: any) => {
        if (variant._id === id) {
          variant.selected = idx;
        }
      });
      this.$store.commit("product/setProduct", product);
    }
    const variantSelected = this.product.listVariantOptionId.map(
      (variant: any) => variant.values[variant.selected]
    );
    const findVariant = this.product.listVariantSellerId.find(
      (variant: any) => {
        return variant.listValue.join(" / ") === variantSelected.join(" / ");
      }
    );
    this.findVariant = findVariant;
    this.variantActive = findVariant;
    this.priceVariant = findVariant?.price || 0;
    if (findVariant?.comparePrice !== findVariant?.price) {
      this.priceProduct = findVariant?.comparePrice || 0;
    }
    let findIdx = -1;
    if (findVariant) {
      findIdx = this.listImage.findIndex(
        (img: any) => img.imageUrl === findVariant?.imageId?.imageUrl
      );
      if (findVariant?.imageId && findVariant?.imageId.imageUrl) {
        if (this.countImgThumb > 0) {
          this.parseImageThumb = `${api}/${findVariant?.imageId.imageUrl}`;
        } else {
          if (
            this.product &&
            this.product.listImageId[0] &&
            this.product.listImageId[0].imageUrl
          ) {
            this.parseImageThumb = `${api}/${
              this.product?.listImageId[0]?.imageUrl ||
              findVariant?.imageId.imageUrl
            }`;
          } else {
            this.parseImageThumb = "";
          }
        }
      }
      if (findVariant?._id) {
        this.payload.variantId = findVariant?._id;
      }
    }
    if (this.countImgThumb > 0) {
      if (findIdx === -1) {
        this.selected = null;
        //@ts-ignore
        this.idxCarousel = null;
      } else {
        this.idxCarousel = findIdx;
        this.selected = idx;
        for (let i = 0; i < 2; i++) {
          setTimeout(() => {
            document
              .getElementsByClassName(
                `carousel-item-left${this.idxCarousel}`
              )[0]
              //@ts-ignore
              .click();
          });
          await this.$utils.sleep(600);
        }
      }
    }
    this.imageId = id;
    this.countImgThumb += 1;
    //@ts-ignore
    // //@ts-ignore
    // this.$refs.carouselClick.click();
  }
  convertImg(product: any) {
    if (product?.coverId?.imageUrl) {
      return `${api}/${product.coverId.imageUrl}`;
    }
    return "";
  }
  convertImageReply(image: string) {
    return `${api}/${image}`;
  }
  convertImageReview(url: string) {
    return `${api}/${url}`;
  }
  convertImage(comboProduct: any) {
    if (comboProduct.variant.length) {
      const findVariant = comboProduct.variant.find(
        (variant: any) => variant._id === comboProduct.variantId
      );
      if (findVariant?.imageId?.imageUrl) {
        return `${api}/${findVariant.imageId.imageUrl}`;
      }
      return "";
    } else if (comboProduct?.coverId?.imageUrl) {
      return `${api}/${comboProduct.coverId.imageUrl}`;
    }
    return "";
  }

  calcPrice(product: any) {
    let price = 0;
    if (product.variant && product.variant.length) {
      for (let variant of product.variant) {
        price += variant.price;
      }
    } else {
      price = product.salePrice;
    }
    return price;
  }
  get priceSale() {
    if (this.variantActive && this.variantActive.price) {
      const promotionStauts = this.$store.state.promotion.promotionStauts;
      if (promotionStauts == 0) {
        return this.variantActive.comparePrice;
      } else {
        return this.variantActive.price;
      }
    } else {
      return this.product.salePrice;
    }
  }

  get priceProduct() {
    return this.$store.state.product.priceProduct;
    // if (!this.variantActive && !this.variantActive.comparePrice) {
    // 	return this.$store.state.product.priceProduct;
    // 	// return product?.listVariantSellerId[0]?.comparePrice || 0;
    // } else {
    // 	return this.variantActive.comparePrice || 0;
    // }
  }

  set priceProduct(value) {
    this.$store.commit("product/setPriceProduct", value);
  }

  get priceVariant() {
    return this.$store.state.product.priceVariant;
    if (!this.variantActive && !this.variantActive.price) {
      // return product?.listVariantSellerId[0]?.price || 0;
    } else {
      return this.variantActive.price || 0;
    }
  }

  set priceVariant(value) {
    this.$store.commit("product/setPriceVariant", value);
  }

  get stateVariant() {
    const findVariant = this.product.variant[this.selected];
    return findVariant || {};
  }
  get statusPromotion() {
    const promotion = this.$store.state.promotion.promotion;
    return promotion.status ? true : false;
  }
  get totalPriceAddTocart() {
    let price = 0;
    for (let id of this.listProductIds) {
      const findProduct = this.combo.listProductId.find(
        (product: any) => product._id === id
      );
      price += this.calcPriceProductCombo(findProduct);
    }
    for (let id of this.listRelatedProductIds) {
      const findProduct = this.product.relatedProduct.find(
        (product: any) => product._id === id
      );
      price += this.calcPriceProductCombo(findProduct);
    }
    return price;
  }
  get promotionStauts() {
    return this.$store.state.promotion.promotionStauts;
  }
  imgThumbnail() {
    if (!this.listImage?.length) return "";
    const findImageThumbnail = this.listImage[this.idxCarousel];
    if (findImageThumbnail) {
      return `${this.api}/${findImageThumbnail.imageUrl}`;
    }
    if (this.parseImageThumb) {
      return "";
    }
    return `${api}/${this.product?.listVariantSellerId[0]?.imageId?.imageUrl}`;
  }
  calcPriceProductCombo(product: any) {
    if (product.variantId) {
      if (product.variant.length) {
        const findPrice = product.variant.find(
          (variant: any) => variant._id === product.variantId
        );
        if (findPrice) {
          return findPrice.price;
        }
      }
    } else {
      return product.price;
    }
    return 0;
  }

  get totalPriceRelatedAddTocart() {
    let price = 0;
    for (let id of this.listRelatedProductIds) {
      const findProduct = this.combo.relatedProduct.find(
        (product: any) => product._id === id
      );
      price += this.calcPriceRelatedProduct(findProduct);
    }
    return price;
  }
  get siteInfo() {
    return this.$store.state.setting.siteInfo;
  }

  onSliceString(str: string) {
    if (str) {
      const regexImg = /<img.*?src="(.*?)"/g;
      const result = str.replaceAll(regexImg, "");
      return result;
    }
    return "";
  }
  // get isCustomShowDescription() {
  //   let description = this.$utils.cloneDeep(this.product.description);
  //   const result = this.onSliceString(description);
  //   if (result.length < 1000) return "short";
  //   return "middle";
  // }

  get totalPrice() {
    let price = 0;
    if (this.listCart && this.listCart.length) {
      for (let product of this.listCart) {
        price += product.price * product.quantity;
      }
    }
    return price;
  }

  calcPriceRelatedProduct(product: any) {
    if (product.variantId) {
      if (product.variant.length) {
        const findPrice = product.variant.find(
          (variant: any) => variant._id === product.variantId
        );
        if (findPrice) {
          return findPrice.price;
        }
      }
    } else {
      return product.price;
    }
    return 0;
  }
  convertImageCarousel(item: any) {
    if (item.imageUrl) {
      return `${api}/${item.imageUrl}`;
    }
    return "";
  }
  convertImageProduct(imageUrl: string) {
    return `${api}/${imageUrl}`;
  }
  formatDate(date: string) {
    return moment(date).format("HH:mm YYYY/MM/DD");
  }
  onSliceEmail(email: string) {
    if (email && typeof email === "string") {
      const emailSplit = email.split("@");
      const emailLeft = emailSplit[0].slice(0, 4) + "****";
      const emailRight = emailSplit[1];
      const emailResult = `${emailLeft}@${emailRight}`;
      return emailResult;
    }
    return "";
  }
  timer = "";
  x: any = null;
  onCalcTimer() {
    const that = this;
    this.x = setInterval(function () {
      const promotion = that.$store.state.promotion.promotion;
      const promotionStauts = that.$store.state.promotion.promotionStauts;
      if (promotionStauts === 1) {
        // Get today's date and time
        var now = new Date().getTime();
        // Find the distance between now and the count down date
        var distance = promotion.to * 1000 - now;
        // Time calculations for days, hours, minutes and seconds
        var days = Math.floor(distance / (1000 * 60 * 60 * 24));
        var hours = Math.floor(
          (distance % (1000 * 60 * 60 * 24)) / (1000 * 60 * 60)
        );
        var minutes = Math.floor((distance % (1000 * 60 * 60)) / (1000 * 60));
        var seconds = Math.floor((distance % (1000 * 60)) / 1000);
        that.timer = `${
          days
            ? days < 10
              ? `0${days} ${days > 1 ? `days` : "day"} `
              : `${days} ${days > 1 ? `days` : "day"} `
            : ""
        }${hours ? (hours < 10 ? `0${hours}:` : `${hours}:`) : "00:"}${
          minutes ? (minutes < 10 ? `0${minutes}:` : `${minutes}:`) : "00:"
        }${seconds ? (seconds < 10 ? `0${seconds}` : `${seconds}`) : ""}`;
        if (distance < 0) {
          clearInterval(that.x);
          that.timer = "";
        }
      } else {
        clearInterval(that.x);
        that.timer = "";
      }
    }, 1000);
  }

  @Watch("$vuetify.breakpoint.name")
  changedScreen(value: string) {
    if (value === "xs" || value === "sm") {
      this.isCheckScreenMobile = true;
    } else {
      this.isCheckScreenMobile = false;
    }
  }
}
</script>

<style src="./style.css"></style>

<style lang="scss" scoped>
.carousel-sub-item {
  min-width: 64px;
  max-width: 64px;
  height: 64px;
  padding: 0 4px;
  img {
    width: 100%;
    height: 100%;
    object-fit: scale-down;
  }
}
.image-review {
  max-width: 152px;
  min-width: 152px;
  height: 152px;
}

.image-review img {
  border-radius: 4px;
}
.icon {
  width: 23px;
  height: 23px;
  margin-right: 8px;
}

.main-home {
  @media (min-width: 768px) {
    padding-bottom: 105px;
  }
}

.checkout-img {
  max-width: 100%;
  width: 100%;

  img {
    width: 100%;
    height: 100%;
    object-fit: cover;
  }
}

.main-img {
  margin: 0 auto;
  max-width: 452px;
  width: 100%;
  height: 452px;
  border-radius: 5px;
  overflow: hidden;

  img {
    width: 100%;
    height: 100%;
    object-fit: scale-down;
  }
  @media (max-width: 768px) {
    max-width: 275px;
    height: 275px;
  }
  @media (max-width: 575px) {
    max-width: 375px;
    height: 375px;
  }
}

.input-fr {
  p {
    font-size: clamp(14px, 1.5vw, 16px);
    line-height: 150%;
    color: white;
  }

  .quantity-input {
    background: white;
    max-width: 105px;
    width: 100%;
    border: 1px solid #dbdbdb;
    height: 55px;
    margin-right: 10px;

    .quanity-number {
      max-width: 32px;
      outline: 0;
      border: 0 !important;
      text-align: center;
    }

    @media (max-width: 960px) {
      margin: 0 0 8px;
    }
  }

  .cart-btn {
    max-width: 167px;
    width: 100%;
    height: 55px;
    margin-right: 10px;
    background: #1b1b1b;
    display: flex;
    align-items: center;
    justify-content: center;
    border-radius: 4px;

    @media (max-width: 960px) {
      max-width: 100%;
      margin: 0 0 8px;
    }
  }

  .cart-btn-disabled {
    max-width: 167px;
    width: 100%;
    height: 55px;
    margin-right: 10px;
    background: #333333;
    display: flex;
    align-items: center;
    justify-content: center;
    border-radius: 4px;

    @media (max-width: 960px) {
      max-width: 100%;
      margin: 0 0 8px;
    }
  }

  .cart-btn-disabled-soldout {
    max-width: 167px;
    width: 100%;
    height: 55px;
    margin-right: 10px;
    background: #707575;
    display: flex;
    align-items: center;
    justify-content: center;
    border-radius: 4px;

    @media (max-width: 960px) {
      max-width: 100%;
      margin: 0 0 8px;
    }
  }

  .buy-btn {
    max-width: 150px;
    width: 100%;
    height: 55px;
    background: #ff4343;
    display: flex;
    align-items: center;
    justify-content: center;
    border-radius: 4px;

    @media (max-width: 960px) {
      max-width: 100%;
      margin: 0 0 8px;
    }
  }

  .buy-btn-disabled {
    max-width: 150px;
    width: 100%;
    height: 55px;
    background: #fc5d5d;
    display: flex;
    align-items: center;
    justify-content: center;
    border-radius: 4px;

    @media (max-width: 960px) {
      max-width: 100%;
      margin: 0 0 8px;
    }
  }
}

.litmit-announce {
  font-size: 13px;
  line-height: 150%;
  letter-spacing: 0.25px;

  .limit {
    color: red;
  }

  .number {
    margin: 0 4px;
    font-weight: 700;
  }
}

.wrapper {
  width: 100%;
}
// .carousel {
//   width: 456px;
//   margin: 0px auto;
// }
// .slick-slide {
//   margin: 10px;
// }
// .slick-slide img {
//   width: 100%;
// }
</style>
